'   File Definition Record Types

TYPE DFNKEYTYPE
    DFNFILNAM AS STRING * 10                ' filename and extension
    DFNRECNBR AS STRING * 3                 ' record number (overlayed defs)
    DFNFLDNBR AS STRING * 2                 ' field number (00 = header rec)
END TYPE

TYPE DFNHDRTYPE
    DFNKEY AS DFNKEYTYPE                    ' key data for header
    DFNRECSIZ AS STRING * 4                 ' record size 1-9999
    DFNKEYLEN AS STRING * 3                 ' length of primary key
    DFNRECCNT AS STRING * 5                 ' number of records to allocate
    DFNFILDSC AS STRING * 25                ' description of the file/record
    DFNRETAIN AS STRING * 25                ' retention period/usage
    DFNFILTYP AS STRING * 15                ' type if file (indexed, record)
    DFNDFNCNT AS STRING * 1                 ' number of defined fields
    DFNDFNDAT AS STRING * 298               ' binary data (3 * # defined)
END TYPE

TYPE DFNITMTYPE
    ITMKEY AS DFNKEYTYPE                    ' key data for field
    ITMFLDNAM AS STRING * 6                 ' name of the field
    ITMFLDDSC AS STRING * 24                ' description of the field
    ITMFLDLEN AS STRING * 3                 ' length of the field
    ITMFLDOFF AS STRING * 7                 ' offset,len within record
    ITMFLDTYP AS STRING * 3                 ' data type (ANDIF) + K if key
    ITMFLDPIC AS STRING * 20                ' edit picture for data
END TYPE

